'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; })();

var ELM = exports.ELM = '@@elm';

var createElmMiddleware = function createElmMiddleware(elm) {
  var elmMiddleware = function elmMiddleware(_ref) {
    var dispatch = _ref.dispatch;
    return function (next) {
      return function (action) {
        if (elm.ports && elm.ports[action.type]) elm.ports[action.type].send(action.payload || null);
        next(action);
      };
    };
  };
  var run = function run(store) {
    window.__REDUX_ELM_STORE__ = store;
  };

  return { elmMiddleware: elmMiddleware, run: run };
};

exports.default = createElmMiddleware;
var reducer = exports.reducer = function reducer() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var action = arguments[1];

  var _action$type$split = action.type.split('/');

  var _action$type$split2 = _slicedToArray(_action$type$split, 2);

  var elmAction = _action$type$split2[0];
  var type = _action$type$split2[1];

  if (elmAction === ELM) {
    return action.payload;
  }

  return state;
};